# Define the kmod package name here.
%define kmod_name libreswan
%define src_name libreswan

%define with_ocf %{?_without_ocf:0} %{?!_without_ocf:1}
%if %{with_ocf}
%define ocf _ocf
%endif

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 3.9.9-3.ocf.nopl.vendorconf.el6.i686}

Name:    %{kmod_name}-kmod
Version: 3.6b1
Release: 1%{?dist}%{ocf}_3.9.9_3
Group:   System Environment/Kernel
License: GPLv2
Summary: %{kmod_name} kernel module(s)
URL:     https://libreswan.org/

BuildRequires: redhat-rpm-config
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch: i686 x86_64

# Sources.
Source0:  %{src_name}-%{version}.tar.gz
Source10: kmodtool-%{kmod_name}-el5.sh

# Define the variants for each architecture.
%define basevar ""
# If kvariants isn't defined on the rpmbuild line, build all variants for this architecture.
# Paul: shortcut - don't do variants
%define kvariants ""
%{!?kvariants: %define kvariants %{?basevar} %{?xenvar} %{?paevar}}

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate_kmp %{kmod_name} %{kversion})}

# Disable the building of the debug package(s).
%define debug_package %{nil}

# Define the filter.
%define __find_requires sh %{_builddir}/%{buildsubdir}/filter-requires.sh

%description
This package provides the %{kmod_name} kernel module(s).
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%prep
%setup -q -c -T -a 0
for kvariant in %{kvariants} ; do
    %{__cp} -a %{src_name}-%{version} _kmod_build_$kvariant
done
echo "/usr/lib/rpm/redhat/find-requires | %{__sed} -e '/^ksym.*/d'" > filter-requires.sh
echo "override %{kmod_name} * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf

%build
for kvariant in %{kvariants} ; do
   cd _kmod_build_$kvariant
   %if %{with_ocf}
      echo "ADDING OCF SUPPORT from `pwd`"
      %{__make} KERNELSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant} %{?_smp_mflags} MODULE_DEF_INCLUDE=`pwd`/packaging/ocf/config-all.h MODULE_DEFCONFIG=`pwd`/packaging/ocf/defconfig module
      KSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}
#      %{__make} -C "${KSRC}" %{?_smp_mflags} MODULE_DEF_INCLUDE=`pwd`/packaging/ocf/config-all.h MODULE_DEFCONFIG=`pwd`/packaging/ocf/defconfig M=%PWD/linux/net/ipsec module
   %else
      echo "SKIPPING OCF SUPPORT"
      %{__make} KERNELSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}-%{_target_cpu} %{?_smp_mflags} module
   %endif
   cd ..
done

%install
rm -rf %{buildroot}
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=/lib/modules/%{kversion}/kernel/net/ipsec
for kvariant in %{kvariants} ; do
   %{__install} -d %{buildroot}/$INSTALL_MOD_DIR
   %{__install} _kmod_build_$kvariant/modobj/ipsec.ko %{buildroot}/$INSTALL_MOD_DIR
done

#%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
#%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
#%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
#%{__install} LICENSE %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;
# Remove the unrequired files.
%{__rm} -f %{buildroot}/lib/modules/%{kversion}/modules.*

%files
/lib/modules/%{kversion}/kernel/net/ipsec/ipsec.ko
#%{_sysconfdir}/depmod.d/kmod-%{kmod_name}.conf
#%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/LICENSE

%clean
rm -rf %{buildroot}

%changelog
* Mon Mar 11 2013 Paul Wouters <pwouters@redhat.com> - 3.1
- Customized for libreswan KLIPS kernel module

* Fri Jan 28 2011 Alan Bartlett <ajb@elrepo.org> - 0.5-6
- Updated the spec file to the current ELRepo Project standards.

* Sat Dec 04 2010 Alan Bartlett <ajb@elrepo.org> - 0.5-5
- Updated the packageing to the current ELRepo Project standards.

* Mon Nov 15 2010 Alan Bartlett <ajb@elrepo.org> - 0.5-4
- Adjusted the kmodtool file.

* Sun Nov 14 2010 Alan Bartlett <ajb@elrepo.org> - 0.5-3
- Adjust & verify both the kmodtool file and this spec file.

* Sun Nov 14 2010 Philip J Perry <phil@elrepo.org> - 0.5-2
- Bump release to test updates

* Sat Nov 13 2010 Philip J Perry <phil@elrepo.org> - 0.5-1
- Update for RHEL6 GA release.

* Thu Apr 29 2010 Philip J Perry <phil@elrepo.org> - 0.5-0.1
- Update to latest release.
- Update kmodtool and SPEC file.

* Thu Apr 29 2010 Philip J Perry <phil@elrepo.org> - 0.0-0.1
- Initial el6 build of the kmod package.
